_G.Hide = _G.Hide or {}
Hide.mod_path = ModPath
Hide._data_path = SavePath .. "Hide_options.txt"

Hide.options = {} 
Hide.options_menu = "Hide_menu"
function Hide:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self.options ) )
		file:close()
	end
end

function Hide:Load()
	local file = io.open( self._data_path, "r" )

	if file then
		self.options = json.decode( file:read("*all") )
		file:close()
	end
end

if not Hide.setup then
	Hide:Load()
	if Hide.options.Hider_enable == nil then 
	Hide.options.Hider_enable = true
	Hide:Save()	
	end
	if Hide.options.Assault_visible == nil then 
	Hide.options.Assault_visible = true
	Hide:Save()	
	end
    if Hide.options.Hostage_visible == nil then 
	Hide.options.Hostage_visible = true
	Hide:Save()	
	end
	if Hide.options.Casing_visible == nil then 
	Hide.options.Casing_visible = true
	Hide:Save()	
	end 
    if Hide.options.Nopoint_visible == nil then 
	Hide.options.Nopoint_visible = true
	Hide:Save()	
	end
	if Hide.options.Objective_visible == nil then 
	Hide.options.Objective_visible = true
	Hide:Save()	
	end	
	if Hide.options.Presenter_visible == nil then 
	Hide.options.Presenter_visible = true
	Hide:Save()	
	end
	if Hide.options.Timer_visible == nil then 
	Hide.options.Timer_visible = true
	Hide:Save()	
	end	
	if Hide.options.Radial_health_visible == nil then 
	Hide.options.Radial_health_visible = true
	Hide:Save()	
	end	
	if Hide.options.Equipments_visible == nil then 
	Hide.options.Equipments_visible = true
	Hide:Save()	
	end
	if Hide.options.Ammo_visible == nil then 
	Hide.options.Ammo_visible = true
	Hide:Save()	
	end
	if Hide.options.Stamina_visible == nil then 
	Hide.options.Stamina_visible = false
	Hide:Save()	
	end
	if Hide.options.Hider_enable == nil then 
	Hide.options.Hider_enable = true
	Hide:Save()	
	end
	if Hide.options.Names_visible == nil then 
	Hide.options.Names_visible = true
	Hide:Save()	
	end	
	if Hide.options.Interaction_visible == nil then 
	Hide.options.Interaction_visible = true
	Hide:Save()	
	end
	if Hide.options.TM_Interaction_visible == nil then 
	Hide.options.TM_Interaction_visible = true
	Hide:Save()	
	end	
	if Hide.options.Interact_text_visible == nil then 
	Hide.options.Interact_text_visible = true
	Hide:Save()	
	end	
	if Hide.options.Pickups_visible == nil then 
	Hide.options.Pickups_visible = true
	Hide:Save()	
	end
	Hide:Load()
	Hide.setup = true
	log("Hide-Loaded settings.")
end
Hooks:Add("LocalizationManagerPostInit", "Hide_loc", function(loc)
	LocalizationManager:add_localized_strings({
    ["Hide_options_title"] = "Hide hud parts",
    ["Hide_options_desc"] = "Decide what parts of your hud you want visible",
    ["Hider_enable_title"] = "enable Hud Hider", 
    ["Hider_enable_desc"] = "If disabled this will disable the mod.",

    ["Assault_visible_title"] = "Assault box",
    ["Hostage_visible_title"] = "Hostage box",
    ["Casing_visible_title"] = "Casing box",
    ["Nopoint_visible_title"] = "No point of return box",
    ["Objective_visible_title"] = "Objective box",
    ["Presenter_visible_title"] = "Objective presenter box",
    ["Timer_visible_title"] = "Timer text",
    ["Radial_visible_title"] = "Radial health panel", 
    ["Equipments_visible_title"] = "Equipments", 
    ["Ammo_visible_title"] = "Ammo counter", 
    ["Interaction_visible_title"] = "Interaction circle", 
    ["Interact_text_visible_title"] = "Interaction text", 
    ["TM_Interaction_visible_title"] = "Teammate Interaction circle", 
    ["Pickups_visible_title"] = "Pickups", 
    ["Names_visible_title"] = "Names", 
    ["Stamina_visible_title"] = "Stamina", 
    ["Stamina_visible_desc"] = "By default the stamina is hidden but still works you just can't see it want to see it?",
    ["Reset_hider_title"] = "Reset hider options", 
    ["Reset_hider_desc"] = "this button Resets all options to default",  
  })
end)


	Hooks:Add("MenuManagerSetupCustomMenus", "HideOptions", function( menu_manager, nodes )
		MenuHelper:NewMenu( Hide.options_menu )
	end)

	Hooks:Add("MenuManagerPopulateCustomMenus", "HideOptions", function( menu_manager, nodes )
    
	    MenuCallbackHandler.Hider_enable = function(self, item)
		Hide.options.Hider_enable = (item:value() == "on" and true or false)
		Hide:Save()
	    end
	    MenuCallbackHandler.Assault_visible = function(self, item)
		Hide.options.Assault_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
		MenuCallbackHandler.Hostage_visible = function(self, item)
		Hide.options.Hostage_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.Casing_visible = function(self, item)
		Hide.options.Casing_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
		MenuCallbackHandler.Nopoint_visible = function(self, item)
		Hide.options.Nopoint_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end		
	    MenuCallbackHandler.Objective_visible = function(self, item)
		Hide.options.Objective_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.Presenter_visible = function(self, item)
		Hide.options.Presenter_visible = (item:value() == "on" and true or false)
		Hide:Save()
		end	   
		MenuCallbackHandler.Timer_visible = function(self, item)
		Hide.options.Timer_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end		
	    MenuCallbackHandler.Radial_health_visible = function(self, item)
		Hide.options.Radial_health_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.Equipments_visible = function(self, item)
		Hide.options.Equipments_visible = (item:value() == "on" and true or false)
		Hide:Save()
    	end
	    MenuCallbackHandler.Ammo_visible = function(self, item)
		Hide.options.Ammo_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end
	    MenuCallbackHandler.Stamina_visible = function(self, item)
		Hide.options.Stamina_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end		
	    MenuCallbackHandler.Hider_enable = function(self, item)
		Hide.options.Hider_enable = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.Names_visible = function(self, item)
		Hide.options.Names_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.Interaction_visible = function(self, item)
		Hide.options.Interaction_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.TM_Interaction_visible = function(self, item)
		Hide.options.TM_Interaction_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end
	    MenuCallbackHandler.Interact_text_visible = function(self, item)
		Hide.options.Interact_text_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end	
	    MenuCallbackHandler.Pickups_visible = function(self, item)
		Hide.options.Pickups_visible = (item:value() == "on" and true or false)
		Hide:Save()
	    end
	    MenuCallbackHandler.Reset_hider_options = function(self, item)
		local Ticked = {
			["Hider_enable"] = true,
			["Assault_visible"] = true,
			["Hostage_visible"] = true,
            ["Casing_visible"] = true,
            ["Nopoint_visible"] = true,
            ["Objective_visible"] = true,       
            ["Timer_visible"] = true,			
            ["Presenter_visible"] = true,			
            ["Equipments_visible"] = true,			
            ["Ammo_visible"] = true,			
            ["Names_visible"] = true,			   	
            ["Radial_health_visible"] = true,			   	
            ["Interaction_visible"] = true,			   	
            ["TM_Interaction_visible"] = true,			   	
            ["Interact_text_visible"] = true,			   	
            ["Pickups_visible"] = true,			   	
		}
		local Unticked = {["Stamina_visible"] = true}	
		MenuHelper:ResetItemsToDefaultValue( item, Ticked, true )
		MenuHelper:ResetItemsToDefaultValue( item, Unticked, false )
	end	
		    MenuHelper:AddToggle({
			id = "Hider_enable",
			title = "Hider_enable_title",
			desc = "Hider_enable_desc",
			callback = "Hider_enable",
			menu_id = Hide.options_menu,
			value = Hide.options.Hider_enable,
			priority = 23,
	    })	
	    	MenuHelper:AddDivider({
            id = "hider_divider",
            size = 32,
            menu_id = Hide.options_menu,
            priority = 22,
        })
	    	MenuHelper:AddToggle({
			id = "Assault_visible",
			title = "Assault_visible_title",
			callback = "Assault_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Assault_visible,
			priority = 21,
	    })		 
	    	MenuHelper:AddToggle({
			id = "Casing_visible",
			title = "Casing_visible_title",
			callback = "Casing_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Casing_visible,
			priority = 20,
	    })
		    MenuHelper:AddToggle({
			id = "Nopoint_visible",
			title = "Nopoint_visible_title",
			callback = "Nopoint_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Nopoint_visible,
			priority = 19,
	    })	
		    MenuHelper:AddToggle({
			id = "Hostage_visible",
			title = "Hostage_visible_title",
			callback = "Hostage_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Hostage_visible,
			priority = 18,
	    })		
	        MenuHelper:AddToggle({
			id = "Radial_health_visible",
			title = "Radial_visible_title",
			callback = "Radial_health_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Radial_health_visible,
			priority = 17,
	    })
	        MenuHelper:AddToggle({
			id = "Objective_visible",
			title = "Objective_visible_title",
			callback = "Objective_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Objective_visible,
			priority = 16,
	    })	
	         MenuHelper:AddToggle({
			id = "Presenter_visible",
			title = "Presenter_visible_title",
			callback = "Presenter_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Presenter_visible,
			priority = 15,
	    })	 
	        MenuHelper:AddToggle({
			id = "Timer_visible",
			title = "Timer_visible_title",
			callback = "Timer_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Timer_visible,
			priority = 14,
	    })	
	    	 MenuHelper:AddToggle({
			id = "Equipments_visible",
			title = "Equipments_visible_title",
			callback = "Equipments_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Equipments_visible,
			priority = 13,
	    })	 
	       	MenuHelper:AddToggle({
			id = "Ammo_visible",
			title = "Ammo_visible_title",
			callback = "Ammo_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Ammo_visible,
			priority = 12,
	    })	
	       	MenuHelper:AddToggle({
			id = "Stamina_visible",
			title = "Stamina_visible_title",
			desc = "Stamina_visible_desc",
			callback = "Stamina_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Stamina_visible,
			priority = 11,
	    })	
	        MenuHelper:AddToggle({
			id = "Names_visible",
			title = "Names_visible_title",
			callback = "Names_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Names_visible,
			priority = 10,
		})	
		    MenuHelper:AddToggle({
			id = "Interaction_visible",
			title = "Interaction_visible_title",
			callback = "Interaction_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Interaction_visible,
			priority = 9,
		})	
			MenuHelper:AddToggle({
			id = "Interact_text_visible",
			title = "Interact_text_visible_title",
			callback = "Interact_text_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Interact_text_visible,
			priority = 8,
		})	
			MenuHelper:AddToggle({
			id = "TM_Interaction_visible",
			title = "TM_Interaction_visible_title",
			callback = "TM_Interaction_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.TM_Interaction_visible,
			priority = 7,
		})	
			MenuHelper:AddToggle({
			id = "Pickups_visible",
			title = "Pickups_visible_title",
			callback = "Pickups_visible",
			menu_id = Hide.options_menu,
			value = Hide.options.Pickups_visible,
			priority = 7,
		})	
	        MenuHelper:AddDivider({
            id = "hider_divider2",
            size = 32,
            menu_id = Hide.options_menu,
            priority = 1,
        })
	        MenuHelper:AddButton({
			id = "Reset_hider_options",
			title = "Reset_hider_title",
			desc = "Reset_hider_desc",
			callback = "Reset_hider_options",
			menu_id = Hide.options_menu,
			priority = 0,
        })		  
end )

Hooks:Add("MenuManagerBuildCustomMenus", "HideOptions", function(menu_manager, nodes)
		nodes[Hide.options_menu] = MenuHelper:BuildMenu( Hide.options_menu )
		MenuHelper:AddMenuItem( nodes.lua_mod_options_menu or nodes.blt_options, Hide.options_menu, "Hide_options_title", "Hide_options_desc", 1 )
	end)
