if not ModCore then
	log("[ERROR][Holo] BeardLib is not installed!")
	return
end
_G.HSAS = _G.HSAS or ModCore:new(ModPath .. "Config.xml", false, true)
function HSAS:Init()
	self:init_modules()
	self.Setup = true
    if not MenuUI.Group then
        PVM:log("BeardLib is outdated!")
        return
    end
    if not Global.level_data or not Global.level_data.level_id then return end
    self._menu = MenuUI:new({
    	name = "HSASMenu",
        offset = 8,
        toggle_key = self.Options:GetValue("ToggleKey"),
        toggle_clbk = function(enabled)
        	managers.hud._chatinput_changed_callback_handler:dispatch(enabled)
        end,
        create_items = callback(self, self, "CreateItems"),
    })
end

function HSAS:CreateItems(menu)
	local holder = menu:Menu({name = "holder", w = 150, auto_height = true, position = "LeftCenter"})
	holder:KeyBind({name = "ToggleKey", value = self.Options:GetValue("ToggleKey"), text = "Toggle key", callback = callback(self, self, "Set")})
	holder:Slider({name = "Scale", min = 0.1, max = 1.5, value = HSAS.Options:GetValue("Scale"), callback = callback(self, self, "Set")})
	holder:Slider({name = "Spacing", min = 0.1, max = 1, value = HSAS.Options:GetValue("Spacing"), callback = callback(self, self, "Set")})
end

function HSAS:Set(menu, item)
	HSAS.Options:SetValue(item:Name(), item:Value())
	if managers.hud and managers.hud.recreate_player_info_hud_pd2 then
		managers.gui_data:layout_scaled_fullscreen_workspace(managers.hud._saferect, HSAS.Options:GetValue("Scale"), HSAS.Options:GetValue("Spacing"))		
		managers.hud:recreate_player_info_hud_pd2()
	end
	self._menu.toggle_key = self.Options:GetValue("ToggleKey")
end

if HUDManager then
	Hooks:PreHook(HUDManager, "_setup_player_info_hud_pd2", "HSASPreSetupPlayerInfoHudPD2", function(self)
    	managers.gui_data:layout_scaled_fullscreen_workspace(managers.hud._saferect, HSAS.Options:GetValue("Scale"), HSAS.Options:GetValue("Spacing"))
	end)

	function HUDManager:recreate_player_info_hud_pd2()
		if not self:alive(PlayerBase.PLAYER_INFO_HUD_PD2) then return end
		local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
		self:_create_present_panel(hud)
		self:_create_interaction(hud)
		self:_create_progress_timer(hud)
		self:_create_objectives(hud)
		self:_create_hint(hud)
		self:_create_heist_timer(hud)
		self:_create_temp_hud(hud)
		self:_create_suspicion(hud)
		self:_create_hit_confirm(hud)
		self:_create_hit_direction(hud)
		self:_create_downed_hud()
		self:_create_custody_hud()
		self:_create_waiting_legend(hud)
	end

	core:module("CoreGuiDataManager")
	function GuiDataManager:layout_scaled_fullscreen_workspace(ws, scale, on_screen_scale)
	    local base_res = {x = 1280, y = 720}
	    local res = RenderSettings.resolution
	    local sc = (2 - scale)
	    local aspect_width = base_res.x / self:_aspect_ratio()
	    local h = math.round(sc * math.max(base_res.y, aspect_width))
	    local w = math.round(sc * math.max(base_res.x, aspect_width / h))

	    local safe_w = math.round(on_screen_scale * res.x)
	    local safe_h = math.round(on_screen_scale * res.y)   
	    local sh = math.min(safe_h, safe_w / (w / h))
	    local sw = math.min(safe_w, safe_h * (w / h))
	    local x = res.x / 2 - sh * (w / h) / 2
	    local y = res.y / 2 - sw / (w / h) / 2
	    ws:set_screen(w, h, x, y, math.min(sw, sh * (w / h)))
	end
end
if not _G.HSAS.Setup then _G.HSAS:Init() end